'use strict';

/**
 * Module dependencies
 */

/* eslint-disable import/no-unresolved */
/* eslint-disable prefer-template */
// Public node modules.
const _ = require('lodash');
const axios = require('axios');
const querystring = require('querystring')

/* eslint-disable no-unused-vars */
module.exports = {
  provider: 'elasticemail',
  name: 'Elastic Email',
  auth: {
    elasticemail_default_from: {
      label: 'Elastic Email Default From',
      type: 'text'
    },
    elasticemail_default_replyto: {
      label: 'Elastic Email Default Reply-To',
      type: 'text'
    },
    elasticemail_api_key: {
      label: 'Elastic Email API Key',
      type: 'text'
    },
    elasticemail_username: {
      label: 'Elastic Email Username',
      type: 'text'
    }
  },
  init: (config) => {

    return {
      send: (options, cb) => {
        return new Promise((resolve, reject) => {
          // Default values.
          options = _.isObject(options) ? options : {};
          options.from = options.from || config.elasticemail_default_from;
          options.replyTo = options.replyTo || config.elasticemail_default_replyto;
          options.text = options.text || options.html;
          options.html = options.html || options.text;

          let msg = {
            from: (typeof(options.from === 'string')) ? options.from : options.from.name,
            to: options.to,
            replyTo: options.replyTo,
            subject: options.subject,
            bodyText: options.text || '',
            bodyHtml: options.html || '',
            isTransactional: true
          };

          console.log("[strapi-email-elasticemail] Attempting to send message: ");
          console.log(msg);

          var _endpoint = 'https://api.elasticemail.com/v2/email/send/';
          _endpoint += `?apiKey=${config.elasticemail_api_key}`;

          axios.post(_endpoint, querystring.stringify(msg))
            .then(response => {
              console.log("-> [strapi-email-elasticemail] Success! ", response);
              resolve();
            }).catch(err => {
              console.log("-> [strapi-email-elasticemail] ERROR: " + err);
              reject([{ messages: [{ id: 'Auth.form.error.email.invalid' }] }]);
            });
        });
      }
    };
  }
};
